=== debian/control ===
Source: ros-indigo-rotors-gazebo-plugins
Section: misc
Priority: extra
Maintainer: Fadri Furrer <fadri.furrer@mavt.ethz.ch>
Build-Depends: debhelper (>= 9.0.0), gazebo2, libgoogle-glog-dev, libprotobuf-dev, libprotoc-dev, libyaml-cpp-dev, protobuf-compiler, ros-indigo-catkin, ros-indigo-cmake-modules, ros-indigo-cv-bridge, ros-indigo-gazebo-plugins, ros-indigo-gazebo-ros, ros-indigo-geometry-msgs, ros-indigo-mav-msgs, ros-indigo-mavros, ros-indigo-octomap, ros-indigo-octomap-msgs, ros-indigo-octomap-ros, ros-indigo-rosbag, ros-indigo-roscpp, ros-indigo-rotors-comm, ros-indigo-rotors-control, ros-indigo-std-srvs, ros-indigo-tf
Homepage: https://github.com/ethz-asl/rotors_simulator
Standards-Version: 3.9.2

Package: ros-indigo-rotors-gazebo-plugins
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, gazebo2, libgoogle-glog-dev, libprotobuf-dev, libprotoc-dev, libyaml-cpp-dev, protobuf-compiler, ros-indigo-cmake-modules, ros-indigo-cv-bridge, ros-indigo-gazebo-plugins, ros-indigo-gazebo-ros, ros-indigo-geometry-msgs, ros-indigo-mav-msgs, ros-indigo-mavros, ros-indigo-octomap, ros-indigo-octomap-msgs, ros-indigo-octomap-ros, ros-indigo-rosbag, ros-indigo-roscpp, ros-indigo-rotors-comm, ros-indigo-rotors-control, ros-indigo-std-srvs, ros-indigo-tf
Description: The rotors_gazebo_plugins package
